/*     GRAM3        */

analisis(F,X,Y):- asercion(F,X,Y).

asercion(F) --> sn(S), verb(S,X,F),compl(X).

compl([])--> [].
compl([arg(X,O)|Y])--> prep(X),sn(O),compl(Y).
compl([arg(nulo,O)|Y])--> sn(O),compl(Y).

sn(S)--> npr(S).
sn(S)--> det,n(S).

verb(S,A,F)--> [W],{verbo(W,S,A,F)}.
npr(W)--> [W],{npropio(W)}.
n(F)--> [W],{nombre(W,_,F)}.
det--> [W],{determ(W)}.
prep(W)--> [W],{prepo(W)}.

/* LEXICON */

npropio(clara).
npropio(maria).
npropio(juan).
npropio(barcelona).

nombre(libro,K,libro(K)).
nombre(hombre,K,hombre(K)).
nombre(profesor,K,profesor(K)).

determ(un).
determ(el).

prepo(en).
prepo(con).
prepo(de).

verbo(rie,S,[],reir(S)).
verbo(piensa,S,[arg(en,O)],pensar_en(S,O)).
verbo(habla,S,[arg(de,O),arg(con,O1)],comunica(S,O,O1)).
verbo(habla,S,[arg(con,O),arg(de,O1)],comunica(S,O1,O)).
verbo(esta,S,[arg(en,O)],locativo(S,O)).
verbo(lee,S,[arg(nulo,O)],leer(S,O)).
